'use strict';

const Controller = require('egg').Controller;
// APP活跃用户总数统计分析模块
class AppActiveUserController extends Controller {

  // app活跃用户总数
  async index() {
    const { ctx, service } = this;
    // 校验参数 组装参数
    const payload = ctx.validate();
    // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = ctx.getData(payload);
      ctx.success({ data });
    } else {
      const data = await service.tRbacUserService.index(payload, 'activeAppTotal');
      // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }

  // app活跃用户位置分布
  async location() {
    const { ctx, service } = this;
    // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = ctx.getArea();
      ctx.success({ data });
    } else {
      const data = await service.onlineUserService2.place('appActiveLocation');
      // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }

  // app活跃用户性别和年龄
  async sexAndAge() {
    const { ctx, service } = this;

    // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = ctx.getSex2Age();
      ctx.success({ data });
    } else {
      const data = await service.tRbacUserService.sexAndAge('activeAppSexAndAgeTotal');
      // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }

}

module.exports = AppActiveUserController;
