'use strict';

const Controller = require('egg').Controller;
// APP功能统计分析模块
class AppBehaviorController extends Controller {

  // APP功能时长排序
  async duration() {
    const { ctx, service } = this;
    // 校验参数 组装参数
    const payload = ctx.validate();
    // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = ctx.getBehavior('duration');
      ctx.success({ data });
    } else {
      const data = await service.appBehaviorRecordService.duration(payload);
      // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }

  // APP功能次数排序
  async count() {
    const { ctx, service } = this;
    // 校验参数 组装参数
    const payload = ctx.validate();
    // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = ctx.getBehavior('count');
      ctx.success({ data });
    } else {
      const data = await service.appBehaviorRecordService.count(payload);
      // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }

  async ext() {
    const { ctx, service } = this;
    // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = ctx.getAppExt();
      ctx.success({ data });
    } else {
      const data = await service.appBehaviorRecordService.ext();
      // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }

  // 远控功能次数统计
  async rc() {
    const { ctx, service } = this;
    // 校验参数 组装参数
    const payload = ctx.validate();
    // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = ctx.getData(payload);
      ctx.success({ data });
    } else {
      const data = await service.appBehaviorRecordService.rc(payload);
      // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }

  // 远控功能执行失败统计
  async rcFail() {
    const { ctx, service } = this;
    // 校验参数 组装参数
    const payload = ctx.validate();
    // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = ctx.getData(payload);
      ctx.success({ data });
    } else {
      const data = await service.appBehaviorRecordService.rcFail(payload);
      // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }


}

module.exports = AppBehaviorController;
