'use strict';

const Controller = require('egg').Controller;
// APP异常反馈统计分析模块
class AppFeedbackController extends Controller {

  // APP反馈
  async feedback() {
    const { ctx, service } = this;
    // 校验参数 组装参数
    const payload = ctx.validate();
    // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = ctx.getData(payload);
      ctx.success({ data });
    } else {
      const data = await service.appFeedbackRecordService.feedback(payload);
      // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }

  // APP异常
  async exception() {
    const { ctx, service } = this;
    // 校验参数 组装参数
    const payload = ctx.validate();
    // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = ctx.getData(payload, { count: 'total', value: [ 'total', 'sys_count', 'interface_exception_count' ] });
      ctx.success({ data });
    } else {
      const data = await service.appExceptionRecordService.exception(payload);
      // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }


}

module.exports = AppFeedbackController;
