'use strict';

const Controller = require('egg').Controller;

// 车辆基础信息统计分析模块
class CarBaseInfoController2 extends Controller {

  async index() {
    const { ctx, service } = this;
    // 校验参数 组装参数
    const payload = ctx.validate();
    // // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = ctx.getMix(payload, this.ctx.params.id);
      ctx.success({ data });
    } else {
      const data = await service.drivingBehaviorInfoService2.index(payload, this.ctx.params.id);
      // // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }

  async stats() {
    const { ctx, service } = this;
    // 校验参数 组装参数
    const payload = ctx.validate();
    // // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = ctx.getMix(payload, this.ctx.params.id);
      ctx.success({ data });
    } else {
      const data = await service.statsBaseInfoService2.stats(payload, this.ctx.params.id);
      // // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }

  async statsWithMode() {
    const { ctx, service } = this;
    // 校验参数 组装参数
    const payload = ctx.validate();
    // // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = ctx.getMix(payload, this.ctx.params.id);
      ctx.success({ data });
    } else {
      const data = await service.statsBaseInfoService2.statsWithMode(payload, this.ctx.params.id);
      // // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }

  async dece() {
    const { ctx, service } = this;
    // 校验参数 组装参数
    const payload = ctx.validate();
    // // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = ctx.get3D(7, 10);
      ctx.success({ data });
    } else {
      const data = await service.statsBaseInfoService2.dece(payload);
      // // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }

  async acce() {
    const { ctx, service } = this;
    // 校验参数 组装参数
    const payload = ctx.validate();
    // // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = ctx.get3D(6, 10);
      ctx.success({ data });
    } else {
      const data = await service.statsBaseInfoService2.acceAndAs(payload, 'acce');
      // // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }

  async as() {
    const { ctx, service } = this;
    // 校验参数 组装参数
    const payload = ctx.validate();
    // // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = ctx.get3D(6, 12);
      ctx.success({ data });
    } else {
      const data = await service.statsBaseInfoService2.acceAndAs(payload, 'as');
      // // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }

  async count() {
    const { ctx, service } = this;
    // 校验参数 组装参数
    const payload = ctx.validate();
    // // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = ctx.getData(payload);
      ctx.success({ data });
    } else {
      const data = await service.drivingBehaviorInfoService2.count(payload, this.ctx.params.id);
      // // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }


}

module.exports = CarBaseInfoController2;
