'use strict';

const Controller = require('egg').Controller;
// 用户登录信息统计分析模块
class UserLoginController extends Controller {

  // 登录方式
  async mode() {
    const { ctx, service } = this;
    // 校验参数 组装参数
    const payload = ctx.validate();

    // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = ctx.getData(payload, {
        value: [ 'faceTotal', 'voiceTotal', 'pwdTotal', 'codeTotal', 'scanTotal' ] });
      ctx.success({ data });
    } else {
      const data = await service.onlineUserService2.mode(payload);
      // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }

  // 登录渠道
  async channel() {
    const { ctx, service } = this;
    // 校验参数 组装参数
    const payload = ctx.validate();

    // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = ctx.getData(payload, { value: [ 'appTotal', 'iviTotal' ] });
      ctx.success({ data });
    } else {
      const data = await service.onlineUserService2.channel(payload);
      // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }
  // 登录角色
  async role() {
    const { ctx, service } = this;
    // 校验参数 组装参数
    const payload = ctx.validate();

    // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = ctx.getData(payload, { value: [ 'carTotal', 'commonTotal', 'guestTotal' ] });
      ctx.success({ data });
    } else {
      const data = await service.onlineUserService2.role(payload);
      // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }
  // 登录状态
  async status() {
    const { ctx, service } = this;
    // 校验参数 组装参数
    const payload = ctx.validate();

    // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = ctx.getData(payload, { value: [ 'successTotal', 'failTotal' ] });
      ctx.success({ data });
    } else {
      const data = await service.onlineUserService2.status(payload);
      // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }
}

module.exports = UserLoginController;
