'use strict';
module.exports = app => {
  const mongoose = app.mongoose;
  const Schema = mongoose.Schema;
  const conn = app.mongooseDB.get('etlLocalDB');

  const TFsmHitorySchema = new Schema({
    create_date: { type: Number }, // 统计的数据是哪一天的
    year: { type: Number }, // 年 统计的数据
    month: { type: Number }, // 月 统计的数据
    day: { type: Number }, // 日 统计的数据
    dateString: { type: String }, // 时间字符串  yyyy-MM-dd
    start_time: { type: Date }, // 开始统计时间
    end_time: { type: Date, default: Date.now }, // 结束统计时间

    danger_drive_cnt: { type: Number }, // 危险事件报警次数
    safety_air_bag_cnt: { type: Number }, // 安全气囊弹出次数
    fault_cnt: { type: Number }, // 故障行驶次数
    long_drive_cnt: { type: Number }, // 长时行驶次数
    speeding_cnt: { type: Number }, // 超速行驶次数
    un_tie_sb_cnt: { type: Number }, // 未系安全带次数
    leave_sw_cnt: { type: Number }, // 双手离开方向盘次数
    acceleration_cnt: { type: Number }, // 急加速次数
    decelerate_cnt: { type: Number }, // 加减速次数
    turn_cnt: { type: Number }, // 急转弯次数
    clu_cnt: { type: Number }, // 急换道次数
    fault_type1: { type: Number }, // 故障类型1
    fault_type2: { type: Number }, // 故障类型2
    fault_type3: { type: Number }, // 故障类型3
    fault_type4: { type: Number }, // 故障类型4
    fault_type5: { type: Number }, // 故障类型5
    fault_type6: { type: Number }, // 故障类型6
    fault_type7: { type: Number }, // 故障类型7
    v_parking_cnt: { type: Number }, // 代客泊车次数
    acc_cnt: { type: Number }, // ACC次数
    intel: { type: Number }, // 智能驾驶行程数
    pack: { type: Number }, // 代客泊车行程数
    acc: { type: Number }, // 自适应巡航行程数
    mileage_cnt: { type: Number }, // 行程数


  });
  TFsmHitorySchema.index({ create_date: -1 });
  return conn.model('TFsmHitory', TFsmHitorySchema, 'lc_t_fsm_hitory');
};
