'use strict';
module.exports = app => {
  const mongoose = app.mongoose;
  const Schema = mongoose.Schema;
  const conn = app.mongooseDB.get('etlLocalDB');
  // 车辆 本地清洗 数据结构
  const TVehicleRecordSchema = new Schema({
    create_date: { type: Number }, // 统计的数据是哪一天的
    year: { type: Number }, // 年 统计的数据
    month: { type: Number }, // 月 统计的数据
    day: { type: Number }, // 日 统计的数据
    dateString: { type: String }, // 时间字符串  yyyy-MM-dd
    start_time: { type: Date }, // 开始统计时间
    end_time: { type: Date, default: Date.now }, // 结束统计时间

    total: { type: Number }, // 车辆总数
    car: [
      {
        _id: {
          series_code: { type: String }, // 车系
          model_code: { type: String }, // 车型
        },
        series_name: { type: String }, // 车系名称
        model_name: { type: String }, // 车型名称
        count: { type: Number }, // 数量
        saledCount: { type: Number }, // 实销数量
        activeCount: { type: Number }, // 活跃车数量
      },
    ], // 入网/实销车车分类
    onlineCar: [
      {
        _id: {
          series_code: { type: String }, // 车系
          model_code: { type: String }, // 车型
        },
        count: { type: Number }, // 数量
      },
    ], // 在线车分类
  });
  TVehicleRecordSchema.index({ create_date: -1 });
  return conn.model('TVehicleRecord', TVehicleRecordSchema, 'lc_t_vehicle_record');
};
