'use strict';
module.exports = app => {
  const mongoose = app.mongoose;
  const Schema = mongoose.Schema;
  const conn = app.mongooseDB.get('etlDB');
  // IVI用户行为埋点，类似APP行为埋点  联合驾驶行为集合统计听歌，听新闻等行程 临时使用用于计算
  const TempSchema = new Schema({
    _id: { type: String }, // vin+behavior_id+ 日月年+序列号
    user_id: { type: String }, // IVI用户ID
    vin: { type: String }, // 车辆VIN
    behavior_id: { type: Number }, // 行为ID  听歌20020000，听电台20010000，看新闻20050000，看视频 20030000
    create_time: { type: Number }, // 行为开始时间

  });

  TempSchema.index({ create_time: -1 });
  TempSchema.index({ create_time: -1, vin: -1 });
  return conn.model('Temp', TempSchema, 'temp');
};
