'use strict';

/**
 *
 * @param {Egg.Application} app - egg application
 */
module.exports = app => {
  const { router, controller } = app;
  router.get('/', controller.home.index);
  router.get('/getMenu', controller.home.getMenu);
  router.post('/task', controller.home.task);
  // 字典
  require('./router/dict')(app);
  // 单车
  require('./router/car')(app);
  // BR01 平台用户统计分析管理
  require('./router/br01_user')(app);
  // BR02 在线用户统计分析管理
  require('./router/br02_onlineUser_2')(app);
  // BR03 车辆行驶数据分析
  require('./router/br03_vehicleDriving2')(app);
  // BR04 车辆内饰硬件统计分析管理
  require('./router/br04_vehicleHardware2')(app);
  // BR05 车辆数量统计分析管理
  require('./router/br05_carNumber')(app);
  // BR06 车辆热力分布
  require('./router/br06_carHeat')(app);
  // BR07 车辆基础信息统计分析
  require('./router/br07_carBaseInfo2')(app);
  // BR08 APP用户总数统计分析管理
  require('./router/br08_appUser')(app);
  // BR09 APP新增用户数量统计管理
  require('./router/br09_appNewUser')(app);
  // BR10 APP活跃用户统计分析管理
  require('./router/br10_appActiveUser')(app);
  // BR11 APP功能统计分析管理
  require('./router/br11_appBehavior')(app);
  // BR12 APP异常反馈统计分析管理
  require('./router/br12_appFeedback')(app);
  // BR13 车机用户数量统计分析
  require('./router/br13_iviUser')(app);
  // BR14 车机新增用户数量统计
  require('./router/br14_iviNewUser')(app);
  // BR15 车机活跃用户统计分析
  require('./router/br15_iviActiveUser')(app);
  // BR16 用户基础信息统计分析
  require('./router/br16_userInfo')(app);
  // BR17 用户出行信息行为统计分析
  require('./router/br17_userDriving2')(app);
  // BR18 娱乐信息统计分析
  require('./router/br18_iviBehavior')(app);
  // BR19 车辆流量使用统计分析
  require('./router/br19_carFlow')(app);
  // BR20 用户登录信息统计分析
  require('./router/br20_userLogin')(app);
  // BR21 消息中心统计分析
  require('./router/br21_msgCenter')(app);
  // BR22 车辆状态云端监控统计
  require('./router/br22_carStatusCloud')(app);
  // BR23 TBox自动化测试分布
  require('./router/br23_tboxAutoTest')(app);

};
