'use strict';

const Controller = require('egg').Controller;

// 字典
class DictController extends Controller {

  constructor(ctx) {
    super(ctx);
    // 特殊的入参校验可以重写在这，默认可以使用commonRule
    ctx.logger.debug('构造');
  }

  // 省份城市
  async place() {
    const { ctx, service } = this;

    // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = [{ _id: '1', province_id: '110000', province_name: '北京市', province_short_name: '', spelling: '', out_pro_code: 'BJ', cities: [{ _id: '1', city_name: '北京市', province_id: '110000', out_city_code: '01', city_id: '1101' }] }, { _id: '2', province_id: '120000', province_name: '天津市', province_short_name: '', spelling: '', out_pro_code: 'TJ', cities: [{ _id: '2', city_name: '天津市', province_id: '120000', out_city_code: '01', city_id: '1201' }] }, { _id: '3', province_id: '130000', province_name: '河北省', province_short_name: '', spelling: '', out_pro_code: 'JI', cities: [{ _id: '3', city_name: '石家庄市', province_id: '130000', out_city_code: '10', city_id: '1301' }, { _id: '4', city_name: '唐山市', province_id: '130000', out_city_code: '11', city_id: '1302' }, { _id: '5', city_name: '秦皇岛市', province_id: '130000', out_city_code: '28', city_id: '1303' }, { _id: '6', city_name: '邯郸市', province_id: '130000', out_city_code: '05', city_id: '1304' }, { _id: '7', city_name: '邢台市', province_id: '130000', out_city_code: '22', city_id: '1305' }, { _id: '8', city_name: '保定市', province_id: '130000', out_city_code: '23', city_id: '1306' }, { _id: '9', city_name: '张家口市', province_id: '130000', out_city_code: '01', city_id: '1307' }, { _id: '10', city_name: '承德市', province_id: '130000', out_city_code: '04', city_id: '1308' }, { _id: '11', city_name: '沧州市', province_id: '130000', out_city_code: '03', city_id: '1309' }, { _id: '12', city_name: '廊坊市', province_id: '130000', out_city_code: '19', city_id: '1310' }, { _id: '13', city_name: '衡水市', province_id: '130000', out_city_code: '06', city_id: '1311' }] }, { _id: '4', province_id: '140000', province_name: '山西省', province_short_name: '', spelling: '', out_pro_code: 'JN', cities: [{ _id: '14', city_name: '太原市', province_id: '140000', out_city_code: '01', city_id: '1401' }, { _id: '15', city_name: '大同市', province_id: '140000', out_city_code: '03', city_id: '1402' }, { _id: '16', city_name: '阳泉市', province_id: '140000', out_city_code: '05', city_id: '1403' }, { _id: '17', city_name: '长治市', province_id: '140000', out_city_code: '02', city_id: '1404' }, { _id: '18', city_name: '晋城市', province_id: '140000', out_city_code: '06', city_id: '1405' }, { _id: '19', city_name: '朔州市', province_id: '140000', out_city_code: '07', city_id: '1406' }, { _id: '20', city_name: '忻州市', province_id: '140000', out_city_code: '10', city_id: '1422' }, { _id: '21', city_name: '吕梁市', province_id: '140000', out_city_code: '12', city_id: '1423' }, { _id: '22', city_name: '晋中市', province_id: '140000', out_city_code: '08', city_id: '1424' }, { _id: '23', city_name: '临汾市', province_id: '140000', out_city_code: '04', city_id: '1426' }, { _id: '24', city_name: '运城市', province_id: '140000', out_city_code: '09', city_id: '1427' }] }, { _id: '5', province_id: '150000', province_name: '内蒙古自治区', province_short_name: '', spelling: '', out_pro_code: 'NM', cities: [{ _id: '25', city_name: '呼和浩特市', province_id: '150000', out_city_code: '01', city_id: '1501' }, { _id: '26', city_name: '包头市', province_id: '150000', out_city_code: '02', city_id: '1502' }, { _id: '27', city_name: '乌海市', province_id: '150000', out_city_code: '05', city_id: '1503' }, { _id: '28', city_name: '赤峰市', province_id: '150000', out_city_code: '03', city_id: '1504' }, { _id: '29', city_name: '呼伦贝尔市', province_id: '150000', out_city_code: '07', city_id: '1521' }, { _id: '30', city_name: '兴安盟', province_id: '150000', out_city_code: '12', city_id: '1522' }, { _id: '31', city_name: '通辽市', province_id: '150000', out_city_code: '06', city_id: '1523' }, { _id: '32', city_name: '锡林郭勒盟', province_id: '150000', out_city_code: '09', city_id: '1525' }, { _id: '33', city_name: '乌兰察布市', province_id: '150000', out_city_code: '08', city_id: '1526' }, { _id: '34', city_name: '巴彦淖尔市', province_id: '150000', out_city_code: '10', city_id: '1528' }, { _id: '35', city_name: '阿拉善盟', province_id: '150000', out_city_code: '11', city_id: '1529' }, { _id: '36', city_name: '鄂尔多斯市', province_id: '150000', out_city_code: '04', city_id: '1530' }, { _id: '445', city_name: '牙克石市', province_id: '150000', out_city_code: '01', city_id: '1501' }] }, { _id: '6', province_id: '210000', province_name: '辽宁省', province_short_name: '', spelling: '', out_pro_code: 'LN', cities: [{ _id: '37', city_name: '沈阳市', province_id: '210000', out_city_code: '12', city_id: '2101' }, { _id: '38', city_name: '大连市', province_id: '210000', out_city_code: '04', city_id: '2102' }, { _id: '39', city_name: '鞍山市', province_id: '210000', out_city_code: '02', city_id: '2103' }, { _id: '40', city_name: '抚顺市', province_id: '210000', out_city_code: '06', city_id: '2104' }, { _id: '41', city_name: '本溪市', province_id: '210000', out_city_code: '14', city_id: '2105' }, { _id: '42', city_name: '丹东市', province_id: '210000', out_city_code: '05', city_id: '2106' }, { _id: '43', city_name: '锦州市', province_id: '210000', out_city_code: '09', city_id: '2107' }, { _id: '44', city_name: '营口市', province_id: '210000', out_city_code: '01', city_id: '2108' }, { _id: '45', city_name: '阜新市', province_id: '210000', out_city_code: '07', city_id: '2109' }, { _id: '46', city_name: '辽阳市', province_id: '210000', out_city_code: '10', city_id: '2110' }, { _id: '47', city_name: '盘锦市', province_id: '210000', out_city_code: '11', city_id: '2111' }, { _id: '48', city_name: '铁岭市', province_id: '210000', out_city_code: '15', city_id: '2112' }, { _id: '49', city_name: '朝阳市', province_id: '210000', out_city_code: '26', city_id: '2113' }, { _id: '50', city_name: '葫芦岛市', province_id: '210000', out_city_code: '08', city_id: '2114' }] }, { _id: '7', province_id: '220000', province_name: '吉林省', province_short_name: '', spelling: '', out_pro_code: 'JL', cities: [{ _id: '51', city_name: '长春市', province_id: '220000', out_city_code: '04', city_id: '2201' }, { _id: '52', city_name: '吉林市', province_id: '220000', out_city_code: '05', city_id: '2202' }, { _id: '53', city_name: '四平市', province_id: '220000', out_city_code: '06', city_id: '2203' }, { _id: '54', city_name: '辽源市', province_id: '220000', out_city_code: '21', city_id: '2204' }, { _id: '55', city_name: '通化市', province_id: '220000', out_city_code: '08', city_id: '2205' }, { _id: '56', city_name: '白山市', province_id: '220000', out_city_code: '03', city_id: '2206' }, { _id: '57', city_name: '松原市', province_id: '220000', out_city_code: '07', city_id: '2207' }, { _id: '58', city_name: '白城市', province_id: '220000', out_city_code: '02', city_id: '2208' }, { _id: '59', city_name: '延边朝鲜族自治州', province_id: '220000', out_city_code: '41', city_id: '2224' }] }, { _id: '8', province_id: '230000', province_name: '黑龙江省', province_short_name: '', spelling: '', out_pro_code: 'HL', cities: [{ _id: '60', city_name: '哈尔滨市', province_id: '230000', out_city_code: '03', city_id: '2301' }, { _id: '61', city_name: '齐齐哈尔市', province_id: '230000', out_city_code: '07', city_id: '2302' }, { _id: '62', city_name: '鸡西市', province_id: '230000', out_city_code: '14', city_id: '2303' }, { _id: '63', city_name: '鹤岗市', province_id: '230000', out_city_code: '10', city_id: '2304' }, { _id: '64', city_name: '双鸭山市', province_id: '230000', out_city_code: '13', city_id: '2305' }, { _id: '65', city_name: '大庆市', province_id: '230000', out_city_code: '02', city_id: '2306' }, { _id: '66', city_name: '伊春市', province_id: '230000', out_city_code: '15', city_id: '2307' }, { _id: '67', city_name: '佳木斯市', province_id: '230000', out_city_code: '04', city_id: '2308' }, { _id: '68', city_name: '七台河市', province_id: '230000', out_city_code: '16', city_id: '2309' }, { _id: '69', city_name: '牡丹江市', province_id: '230000', out_city_code: '05', city_id: '2310' }, { _id: '70', city_name: '黑河市', province_id: '230000', out_city_code: '11', city_id: '2311' }, { _id: '71', city_name: '绥化市', province_id: '230000', out_city_code: '17', city_id: '2323' }, { _id: '72', city_name: '大兴安岭地区', province_id: '230000', out_city_code: '09', city_id: '2327' }] }, { _id: '9', province_id: '310000', province_name: '上海市', province_short_name: '', spelling: '', out_pro_code: 'SH', cities: [{ _id: '73', city_name: '上海市', province_id: '310000', out_city_code: '01', city_id: '3101' }] }, { _id: '10', province_id: '320000', province_name: '江苏省', province_short_name: '', spelling: '', out_pro_code: 'JS', cities: [{ _id: '74', city_name: '南京市', province_id: '320000', out_city_code: '08', city_id: '3201' }, { _id: '75', city_name: '无锡市', province_id: '320000', out_city_code: '12', city_id: '3202' }, { _id: '76', city_name: '徐州市', province_id: '320000', out_city_code: '14', city_id: '3203' }, { _id: '77', city_name: '常州市', province_id: '320000', out_city_code: '02', city_id: '3204' }, { _id: '78', city_name: '苏州市', province_id: '320000', out_city_code: '10', city_id: '3205' }, { _id: '79', city_name: '南通市', province_id: '320000', out_city_code: '09', city_id: '3206' }, { _id: '80', city_name: '连云港市', province_id: '320000', out_city_code: '07', city_id: '3207' }, { _id: '81', city_name: '淮安市', province_id: '320000', out_city_code: '04', city_id: '3208' }, { _id: '82', city_name: '盐城市', province_id: '320000', out_city_code: '15', city_id: '3209' }, { _id: '83', city_name: '扬州市', province_id: '320000', out_city_code: '16', city_id: '3210' }, { _id: '84', city_name: '镇江市', province_id: '320000', out_city_code: '01', city_id: '3211' }, { _id: '85', city_name: '泰州市', province_id: '320000', out_city_code: '11', city_id: '3212' }, { _id: '86', city_name: '宿迁市', province_id: '320000', out_city_code: '31', city_id: '3213' }] }, { _id: '11', province_id: '330000', province_name: '浙江省', province_short_name: '', spelling: '', out_pro_code: 'ZJ', cities: [{ _id: '87', city_name: '杭州市', province_id: '330000', out_city_code: '03', city_id: '3301' }, { _id: '88', city_name: '宁波市', province_id: '330000', out_city_code: '07', city_id: '3302' }, { _id: '89', city_name: '温州市', province_id: '330000', out_city_code: '11', city_id: '3303' }, { _id: '90', city_name: '嘉兴市', province_id: '330000', out_city_code: '28', city_id: '3304' }, { _id: '91', city_name: '湖州市', province_id: '330000', out_city_code: '04', city_id: '3305' }, { _id: '92', city_name: '绍兴市', province_id: '330000', out_city_code: '09', city_id: '3306' }, { _id: '93', city_name: '金华市', province_id: '330000', out_city_code: '06', city_id: '3307' }, { _id: '94', city_name: '衢州市', province_id: '330000', out_city_code: '12', city_id: '3308' }, { _id: '95', city_name: '舟山市', province_id: '330000', out_city_code: '13', city_id: '3309' }, { _id: '96', city_name: '台州市', province_id: '330000', out_city_code: '10', city_id: '3310' }, { _id: '97', city_name: '丽水市', province_id: '330000', out_city_code: '14', city_id: '3325' }] }, { _id: '12', province_id: '340000', province_name: '安徽省', province_short_name: '', spelling: '', out_pro_code: 'AH', cities: [{ _id: '98', city_name: '合肥市', province_id: '340000', out_city_code: '06', city_id: '3401' }, { _id: '99', city_name: '芜湖市', province_id: '340000', out_city_code: '13', city_id: '3402' }, { _id: '100', city_name: '蚌埠市', province_id: '340000', out_city_code: '02', city_id: '3403' }, { _id: '101', city_name: '淮南市', province_id: '340000', out_city_code: '21', city_id: '3404' }, { _id: '102', city_name: '马鞍山市', province_id: '340000', out_city_code: '14', city_id: '3405' }, { _id: '103', city_name: '淮北市', province_id: '340000', out_city_code: '07', city_id: '3406' }, { _id: '104', city_name: '铜陵市', province_id: '340000', out_city_code: '12', city_id: '3407' }, { _id: '105', city_name: '安庆市', province_id: '340000', out_city_code: '01', city_id: '3408' }, { _id: '106', city_name: '黄山市', province_id: '340000', out_city_code: '15', city_id: '3410' }, { _id: '107', city_name: '滁州市', province_id: '340000', out_city_code: '04', city_id: '3411' }, { _id: '108', city_name: '阜阳市', province_id: '340000', out_city_code: '05', city_id: '3412' }, { _id: '109', city_name: '宿州市', province_id: '340000', out_city_code: '11', city_id: '3413' }, { _id: '110', city_name: '亳州市', province_id: '340000', out_city_code: '17', city_id: '3414' }, { _id: '111', city_name: '六安市', province_id: '340000', out_city_code: '16', city_id: '3424' }, { _id: '112', city_name: '宣城市', province_id: '340000', out_city_code: '19', city_id: '3425' }, { _id: '113', city_name: '池州市', province_id: '340000', out_city_code: '18', city_id: '3429' }] }, { _id: '13', province_id: '350000', province_name: '福建省', province_short_name: '', spelling: '', out_pro_code: 'FJ', cities: [{ _id: '114', city_name: '福州市', province_id: '350000', out_city_code: '02', city_id: '3501' }, { _id: '115', city_name: '厦门市', province_id: '350000', out_city_code: '01', city_id: '3502' }, { _id: '116', city_name: '莆田市', province_id: '350000', out_city_code: '13', city_id: '3503' }, { _id: '117', city_name: '三明市', province_id: '350000', out_city_code: '12', city_id: '3504' }, { _id: '118', city_name: '泉州市', province_id: '350000', out_city_code: '04', city_id: '3505' }, { _id: '119', city_name: '漳州市', province_id: '350000', out_city_code: '06', city_id: '3506' }, { _id: '120', city_name: '南平市', province_id: '350000', out_city_code: '10', city_id: '3507' }, { _id: '121', city_name: '龙岩市', province_id: '350000', out_city_code: '09', city_id: '3508' }, { _id: '122', city_name: '宁德市', province_id: '350000', out_city_code: '15', city_id: '3522' }] }, { _id: '14', province_id: '360000', province_name: '江西省', province_short_name: '', spelling: '', out_pro_code: 'JX', cities: [{ _id: '123', city_name: '南昌市', province_id: '360000', out_city_code: '03', city_id: '3601' }, { _id: '124', city_name: '景德镇市', province_id: '360000', out_city_code: '12', city_id: '3602' }, { _id: '125', city_name: '萍乡市', province_id: '360000', out_city_code: '01', city_id: '3603' }, { _id: '126', city_name: '九江市', province_id: '360000', out_city_code: '04', city_id: '3604' }, { _id: '127', city_name: '新余市', province_id: '360000', out_city_code: '13', city_id: '3605' }, { _id: '128', city_name: '鹰潭市', province_id: '360000', out_city_code: '19', city_id: '3606' }, { _id: '129', city_name: '赣州市', province_id: '360000', out_city_code: '02', city_id: '3607' }, { _id: '130', city_name: '宜春市', province_id: '360000', out_city_code: '05', city_id: '3622' }, { _id: '131', city_name: '上饶市', province_id: '360000', out_city_code: '06', city_id: '3623' }, { _id: '132', city_name: '吉安市', province_id: '360000', out_city_code: '15', city_id: '3624' }, { _id: '133', city_name: '抚州市', province_id: '360000', out_city_code: '14', city_id: '3625' }] }, { _id: '15', province_id: '370000', province_name: '山东省', province_short_name: '', spelling: '', out_pro_code: 'SD', cities: [{ _id: '134', city_name: '济南市', province_id: '370000', out_city_code: '06', city_id: '3701' }, { _id: '135', city_name: '青岛市', province_id: '370000', out_city_code: '12', city_id: '3702' }, { _id: '136', city_name: '淄博市', province_id: '370000', out_city_code: '01', city_id: '3703' }, { _id: '137', city_name: '枣庄市', province_id: '370000', out_city_code: '19', city_id: '3704' }, { _id: '138', city_name: '东营市', province_id: '370000', out_city_code: '03', city_id: '3705' }, { _id: '139', city_name: '烟台市', province_id: '370000', out_city_code: '17', city_id: '3706' }, { _id: '140', city_name: '潍坊市', province_id: '370000', out_city_code: '16', city_id: '3707' }, { _id: '141', city_name: '济宁市', province_id: '370000', out_city_code: '07', city_id: '3708' }, { _id: '142', city_name: '泰安市', province_id: '370000', out_city_code: '14', city_id: '3709' }, { _id: '143', city_name: '威海市', province_id: '370000', out_city_code: '15', city_id: '3710' }, { _id: '144', city_name: '日照市', province_id: '370000', out_city_code: '13', city_id: '3711' }, { _id: '145', city_name: '莱芜市', province_id: '370000', out_city_code: '21', city_id: '3712' }, { _id: '146', city_name: '临沂市', province_id: '370000', out_city_code: '10', city_id: '3713' }, { _id: '147', city_name: '德州市', province_id: '370000', out_city_code: '02', city_id: '3714' }, { _id: '148', city_name: '聊城市', province_id: '370000', out_city_code: '09', city_id: '3715' }, { _id: '149', city_name: '滨州市', province_id: '370000', out_city_code: '22', city_id: '3723' }, { _id: '150', city_name: '菏泽市', province_id: '370000', out_city_code: '05', city_id: '3729' }] }, { _id: '16', province_id: '410000', province_name: '河南省', province_short_name: '', spelling: '', out_pro_code: 'YU', cities: [{ _id: '151', city_name: '郑州市', province_id: '410000', out_city_code: '01', city_id: '4101' }, { _id: '152', city_name: '开封市', province_id: '410000', out_city_code: '06', city_id: '4102' }, { _id: '153', city_name: '洛阳市', province_id: '410000', out_city_code: '07', city_id: '4103' }, { _id: '154', city_name: '平顶山市', province_id: '410000', out_city_code: '09', city_id: '4104' }, { _id: '155', city_name: '安阳市', province_id: '410000', out_city_code: '02', city_id: '4105' }, { _id: '156', city_name: '鹤壁市', province_id: '410000', out_city_code: '03', city_id: '4106' }, { _id: '157', city_name: '新乡市', province_id: '410000', out_city_code: '15', city_id: '4107' }, { _id: '158', city_name: '焦作市', province_id: '410000', out_city_code: '05', city_id: '4108' }, { _id: '159', city_name: '濮阳市', province_id: '410000', out_city_code: '16', city_id: '4109' }, { _id: '160', city_name: '许昌市', province_id: '410000', out_city_code: '13', city_id: '4110' }, { _id: '161', city_name: '漯河市', province_id: '410000', out_city_code: '17', city_id: '4111' }, { _id: '162', city_name: '三门峡市', province_id: '410000', out_city_code: '10', city_id: '4112' }, { _id: '163', city_name: '南阳市', province_id: '410000', out_city_code: '08', city_id: '4113' }, { _id: '164', city_name: '商丘市', province_id: '410000', out_city_code: '11', city_id: '4114' }, { _id: '165', city_name: '信阳市', province_id: '410000', out_city_code: '12', city_id: '4115' }, { _id: '166', city_name: '周口市', province_id: '410000', out_city_code: '18', city_id: '4127' }, { _id: '167', city_name: '驻马店市', province_id: '410000', out_city_code: '19', city_id: '4128' }] }, { _id: '17', province_id: '420000', province_name: '湖北省', province_short_name: '', spelling: '', out_pro_code: 'HB', cities: [{ _id: '168', city_name: '武汉市', province_id: '420000', out_city_code: '07', city_id: '4201' }, { _id: '169', city_name: '黄石市', province_id: '420000', out_city_code: '03', city_id: '4202' }, { _id: '170', city_name: '十堰市', province_id: '420000', out_city_code: '06', city_id: '4203' }, { _id: '171', city_name: '宜昌市', province_id: '420000', out_city_code: '01', city_id: '4205' }, { _id: '172', city_name: '鄂州市', province_id: '420000', out_city_code: '10', city_id: '4207' }, { _id: '173', city_name: '荆门市', province_id: '420000', out_city_code: '04', city_id: '4208' }, { _id: '174', city_name: '孝感市', province_id: '420000', out_city_code: '11', city_id: '4209' }, { _id: '175', city_name: '荆州市', province_id: '420000', out_city_code: '09', city_id: '4210' }, { _id: '176', city_name: '黄冈市', province_id: '420000', out_city_code: '20', city_id: '4211' }, { _id: '177', city_name: '咸宁市', province_id: '420000', out_city_code: '12', city_id: '4212' }, { _id: '178', city_name: '随州市', province_id: '420000', out_city_code: '13', city_id: '4213' }, { _id: '179', city_name: '恩施土家族苗族自治州', province_id: '420000', out_city_code: '14', city_id: '4228' }, { _id: '336', city_name: '襄樊市', province_id: '420000', out_city_code: '41', city_id: '4206' }, { _id: '444', city_name: '省直辖县级行政区域', province_id: '420000', out_city_code: '01', city_id: '4250' }] }, { _id: '18', province_id: '430000', province_name: '湖南省', province_short_name: '', spelling: '', out_pro_code: 'HN', cities: [{ _id: '180', city_name: '长沙市', province_id: '430000', out_city_code: '02', city_id: '4301' }, { _id: '181', city_name: '株洲市', province_id: '430000', out_city_code: '21', city_id: '4302' }, { _id: '182', city_name: '湘潭市', province_id: '430000', out_city_code: '01', city_id: '4303' }, { _id: '183', city_name: '衡阳市', province_id: '430000', out_city_code: '04', city_id: '4304' }, { _id: '184', city_name: '邵阳市', province_id: '430000', out_city_code: '22', city_id: '4305' }, { _id: '185', city_name: '岳阳市', province_id: '430000', out_city_code: '15', city_id: '4306' }, { _id: '186', city_name: '常德市', province_id: '430000', out_city_code: '14', city_id: '4307' }, { _id: '187', city_name: '张家界市', province_id: '430000', out_city_code: '23', city_id: '4308' }, { _id: '188', city_name: '益阳市', province_id: '430000', out_city_code: '18', city_id: '4309' }, { _id: '189', city_name: '郴州市', province_id: '430000', out_city_code: '03', city_id: '4310' }, { _id: '190', city_name: '永州市', province_id: '430000', out_city_code: '20', city_id: '4311' }, { _id: '191', city_name: '怀化市', province_id: '430000', out_city_code: '05', city_id: '4312' }, { _id: '192', city_name: '娄底市', province_id: '430000', out_city_code: '17', city_id: '4325' }, { _id: '193', city_name: '湘西土家族苗族自治州', province_id: '430000', out_city_code: '37', city_id: '4331' }] }, { _id: '19', province_id: '440000', province_name: '广东省', province_short_name: '', spelling: '', out_pro_code: 'GD', cities: [{ _id: '194', city_name: '广州市', province_id: '440000', out_city_code: '04', city_id: '4401' }, { _id: '195', city_name: '韶关市', province_id: '440000', out_city_code: '13', city_id: '4402' }, { _id: '196', city_name: '深圳市', province_id: '440000', out_city_code: '08', city_id: '4403' }, { _id: '197', city_name: '汕头市', province_id: '440000', out_city_code: '07', city_id: '4405' }, { _id: '198', city_name: '佛山市', province_id: '440000', out_city_code: '03', city_id: '4406' }, { _id: '199', city_name: '江门市', province_id: '440000', out_city_code: '22', city_id: '4407' }, { _id: '200', city_name: '湛江市', province_id: '440000', out_city_code: '11', city_id: '4408' }, { _id: '201', city_name: '茂名市', province_id: '440000', out_city_code: '17', city_id: '4409' }, { _id: '202', city_name: '肇庆市', province_id: '440000', out_city_code: '14', city_id: '4412' }, { _id: '203', city_name: '惠州市', province_id: '440000', out_city_code: '18', city_id: '4413' }, { _id: '204', city_name: '梅州市', province_id: '440000', out_city_code: '12', city_id: '4414' }, { _id: '205', city_name: '汕尾市', province_id: '440000', out_city_code: '28', city_id: '4415' }, { _id: '206', city_name: '河源市', province_id: '440000', out_city_code: '16', city_id: '4416' }, { _id: '207', city_name: '阳江市', province_id: '440000', out_city_code: '30', city_id: '4417' }, { _id: '208', city_name: '清远市', province_id: '440000', out_city_code: '32', city_id: '4418' }, { _id: '209', city_name: '东莞市', province_id: '440000', out_city_code: '02', city_id: '4419' }, { _id: '210', city_name: '中山市', province_id: '440000', out_city_code: '27', city_id: '4420' }, { _id: '211', city_name: '潮州市', province_id: '440000', out_city_code: '19', city_id: '4451' }, { _id: '212', city_name: '揭阳市', province_id: '440000', out_city_code: '29', city_id: '4452' }, { _id: '213', city_name: '云浮市', province_id: '440000', out_city_code: '41', city_id: '4453' }, { _id: '214', city_name: '珠海市', province_id: '440000', out_city_code: '01', city_id: '4454' }] }, { _id: '20', province_id: '450000', province_name: '广西壮族自治区', province_short_name: '', spelling: '', out_pro_code: 'GX', cities: [{ _id: '215', city_name: '南宁市', province_id: '450000', out_city_code: '01', city_id: '4501' }, { _id: '216', city_name: '柳州市', province_id: '450000', out_city_code: '03', city_id: '4502' }, { _id: '217', city_name: '桂林市', province_id: '450000', out_city_code: '02', city_id: '4503' }, { _id: '218', city_name: '梧州市', province_id: '450000', out_city_code: '09', city_id: '4504' }, { _id: '219', city_name: '北海市', province_id: '450000', out_city_code: '04', city_id: '4505' }, { _id: '220', city_name: '防城港市', province_id: '450000', out_city_code: '14', city_id: '4506' }, { _id: '221', city_name: '钦州市', province_id: '450000', out_city_code: '13', city_id: '4507' }, { _id: '222', city_name: '贵港市', province_id: '450000', out_city_code: '08', city_id: '4508' }, { _id: '223', city_name: '玉林市', province_id: '450000', out_city_code: '07', city_id: '4509' }, { _id: '224', city_name: '来宾市', province_id: '450000', out_city_code: '20', city_id: '4513' }, { _id: '225', city_name: '崇左市', province_id: '450000', out_city_code: '11', city_id: '4514' }, { _id: '226', city_name: '贺州市', province_id: '450000', out_city_code: '06', city_id: '4524' }, { _id: '227', city_name: '百色市', province_id: '450000', out_city_code: '18', city_id: '4526' }, { _id: '228', city_name: '河池市', province_id: '450000', out_city_code: '10', city_id: '4527' }] }, { _id: '21', province_id: '460000', province_name: '海南省', province_short_name: '', spelling: '', out_pro_code: 'QI', cities: [{ _id: '229', city_name: '海口市', province_id: '460000', out_city_code: '01', city_id: '4601' }, { _id: '230', city_name: '三亚市', province_id: '460000', out_city_code: '02', city_id: '4602' }, { _id: '231', city_name: '三沙市', province_id: '460000', out_city_code: '16', city_id: '4616' }, { _id: '338', city_name: '省直辖县级行政区域', province_id: '460000', out_city_code: '17', city_id: '4617' }, { _id: '339', city_name: '洋浦经济开发区', province_id: '460000', out_city_code: '18', city_id: '4618' }, { _id: '440', city_name: '儋州市', province_id: '460000', out_city_code: '19', city_id: '4619' }] }, { _id: '22', province_id: '500000', province_name: '重庆市', province_short_name: '', spelling: '', out_pro_code: 'CQ', cities: [{ _id: '232', city_name: '重庆市', province_id: '500000', out_city_code: '01', city_id: '5001' }] }, { _id: '23', province_id: '510000', province_name: '四川省', province_short_name: '', spelling: '', out_pro_code: 'SC', cities: [{ _id: '233', city_name: '成都市', province_id: '510000', out_city_code: '02', city_id: '5101' }, { _id: '234', city_name: '自贡市', province_id: '510000', out_city_code: '14', city_id: '5103' }, { _id: '235', city_name: '攀枝花市', province_id: '510000', out_city_code: '19', city_id: '5104' }, { _id: '236', city_name: '泸州市', province_id: '510000', out_city_code: '06', city_id: '5105' }, { _id: '237', city_name: '德阳市', province_id: '510000', out_city_code: '10', city_id: '5106' }, { _id: '238', city_name: '绵阳市', province_id: '510000', out_city_code: '04', city_id: '5107' }, { _id: '239', city_name: '广元市', province_id: '510000', out_city_code: '11', city_id: '5108' }, { _id: '240', city_name: '遂宁市', province_id: '510000', out_city_code: '12', city_id: '5109' }, { _id: '241', city_name: '内江市', province_id: '510000', out_city_code: '08', city_id: '5110' }, { _id: '242', city_name: '乐山市', province_id: '510000', out_city_code: '03', city_id: '5111' }, { _id: '243', city_name: '南充市', province_id: '510000', out_city_code: '01', city_id: '5113' }, { _id: '244', city_name: '宜宾市', province_id: '510000', out_city_code: '07', city_id: '5115' }, { _id: '245', city_name: '广安市', province_id: '510000', out_city_code: '09', city_id: '5116' }, { _id: '246', city_name: '达州市', province_id: '510000', out_city_code: '24', city_id: '5117' }, { _id: '247', city_name: '雅安市', province_id: '510000', out_city_code: '22', city_id: '5131' }, { _id: '248', city_name: '阿坝藏族羌族自治州', province_id: '510000', out_city_code: '35', city_id: '5132' }, { _id: '249', city_name: '甘孜藏族自治州', province_id: '510000', out_city_code: '73', city_id: '5133' }, { _id: '250', city_name: '凉山彝族自治州', province_id: '510000', out_city_code: '74', city_id: '5134' }, { _id: '251', city_name: '巴中市', province_id: '510000', out_city_code: '05', city_id: '5137' }, { _id: '252', city_name: '眉山市', province_id: '510000', out_city_code: '16', city_id: '5138' }, { _id: '253', city_name: '资阳市', province_id: '510000', out_city_code: '27', city_id: '5139' }] }, { _id: '24', province_id: '520000', province_name: '贵州省', province_short_name: '', spelling: '', out_pro_code: 'GZ', cities: [{ _id: '254', city_name: '贵阳市', province_id: '520000', out_city_code: '01', city_id: '5201' }, { _id: '255', city_name: '六盘水市', province_id: '520000', out_city_code: '02', city_id: '5202' }, { _id: '256', city_name: '遵义市', province_id: '520000', out_city_code: '03', city_id: '5203' }, { _id: '257', city_name: '黔西南布依族苗族自治州', province_id: '520000', out_city_code: '07', city_id: '5223' }, { _id: '258', city_name: '安顺市', province_id: '520000', out_city_code: '04', city_id: '5225' }, { _id: '259', city_name: '黔东南苗族侗族自治州', province_id: '520000', out_city_code: '08', city_id: '5226' }, { _id: '260', city_name: '黔南布依族苗族自治州', province_id: '520000', out_city_code: '09', city_id: '5227' }, { _id: '335', city_name: '毕节地区', province_id: '520000', out_city_code: '17', city_id: '5224' }, { _id: '337', city_name: '铜仁地区', province_id: '520000', out_city_code: '20', city_id: '5222' }] }, { _id: '25', province_id: '530000', province_name: '云南省', province_short_name: '', spelling: '', out_pro_code: 'YN', cities: [{ _id: '261', city_name: '昆明市', province_id: '530000', out_city_code: '04', city_id: '5301' }, { _id: '262', city_name: '曲靖市', province_id: '530000', out_city_code: '01', city_id: '5303' }, { _id: '263', city_name: '玉溪市', province_id: '530000', out_city_code: '05', city_id: '5304' }, { _id: '264', city_name: '昭通市', province_id: '530000', out_city_code: '07', city_id: '5321' }, { _id: '265', city_name: '楚雄彝族自治州', province_id: '530000', out_city_code: '14', city_id: '5323' }, { _id: '266', city_name: '红河哈尼族彝族自治州', province_id: '530000', out_city_code: '12', city_id: '5325' }, { _id: '267', city_name: '文山壮族苗族自治州', province_id: '530000', out_city_code: '11', city_id: '5326' }, { _id: '268', city_name: '普洱市', province_id: '530000', out_city_code: '29', city_id: '5327' }, { _id: '269', city_name: '西双版纳傣族自治州', province_id: '530000', out_city_code: '13', city_id: '5328' }, { _id: '270', city_name: '大理白族自治州', province_id: '530000', out_city_code: '30', city_id: '5329' }, { _id: '271', city_name: '保山市', province_id: '530000', out_city_code: '06', city_id: '5330' }, { _id: '272', city_name: '德宏傣族景颇族自治州', province_id: '530000', out_city_code: '15', city_id: '5331' }, { _id: '273', city_name: '丽江市', province_id: '530000', out_city_code: '18', city_id: '5332' }, { _id: '274', city_name: '怒江傈僳族自治州', province_id: '530000', out_city_code: '16', city_id: '5333' }, { _id: '275', city_name: '迪庆藏族自治州', province_id: '530000', out_city_code: '17', city_id: '5334' }, { _id: '276', city_name: '临沧市', province_id: '530000', out_city_code: '09', city_id: '5335' }] }, { _id: '26', province_id: '540000', province_name: '西藏自治区', province_short_name: '', spelling: '', out_pro_code: 'XZ', cities: [{ _id: '277', city_name: '拉萨市', province_id: '540000', out_city_code: '01', city_id: '5401' }, { _id: '278', city_name: '昌都地区', province_id: '540000', out_city_code: '04', city_id: '5421' }, { _id: '279', city_name: '山南地区', province_id: '540000', out_city_code: '05', city_id: '5422' }, { _id: '280', city_name: '日喀则地区', province_id: '540000', out_city_code: '02', city_id: '5423' }, { _id: '281', city_name: '那曲地区', province_id: '540000', out_city_code: '03', city_id: '5424' }, { _id: '282', city_name: '阿里地区', province_id: '540000', out_city_code: '06', city_id: '5425' }, { _id: '283', city_name: '林芝地区', province_id: '540000', out_city_code: '07', city_id: '5426' }] }, { _id: '27', province_id: '610000', province_name: '陕西省', province_short_name: '', spelling: '', out_pro_code: 'SS', cities: [{ _id: '284', city_name: '西安市', province_id: '610000', out_city_code: '01', city_id: '6101' }, { _id: '285', city_name: '铜川市', province_id: '610000', out_city_code: '04', city_id: '6102' }, { _id: '286', city_name: '宝鸡市', province_id: '610000', out_city_code: '05', city_id: '6103' }, { _id: '287', city_name: '咸阳市', province_id: '610000', out_city_code: '06', city_id: '6104' }, { _id: '288', city_name: '渭南市', province_id: '610000', out_city_code: '07', city_id: '6105' }, { _id: '289', city_name: '延安市', province_id: '610000', out_city_code: '08', city_id: '6106' }, { _id: '290', city_name: '汉中市', province_id: '610000', out_city_code: '02', city_id: '6107' }, { _id: '291', city_name: '安康市', province_id: '610000', out_city_code: '03', city_id: '6124' }, { _id: '292', city_name: '商洛市', province_id: '610000', out_city_code: '10', city_id: '6125' }, { _id: '293', city_name: '榆林市', province_id: '610000', out_city_code: '09', city_id: '6127' }] }, { _id: '28', province_id: '620000', province_name: '甘肃省', province_short_name: '', spelling: '', out_pro_code: 'GS', cities: [{ _id: '294', city_name: '兰州市', province_id: '620000', out_city_code: '01', city_id: '6201' }, { _id: '295', city_name: '嘉峪关市', province_id: '620000', out_city_code: '05', city_id: '6202' }, { _id: '296', city_name: '金昌市', province_id: '620000', out_city_code: '02', city_id: '6203' }, { _id: '297', city_name: '白银市', province_id: '620000', out_city_code: '03', city_id: '6204' }, { _id: '298', city_name: '天水市', province_id: '620000', out_city_code: '04', city_id: '6205' }, { _id: '299', city_name: '酒泉市', province_id: '620000', out_city_code: '09', city_id: '6221' }, { _id: '300', city_name: '张掖市', province_id: '620000', out_city_code: '07', city_id: '6222' }, { _id: '301', city_name: '武威市', province_id: '620000', out_city_code: '06', city_id: '6223' }, { _id: '302', city_name: '定西市', province_id: '620000', out_city_code: '11', city_id: '6224' }, { _id: '303', city_name: '陇南市', province_id: '620000', out_city_code: '12', city_id: '6226' }, { _id: '304', city_name: '平凉市', province_id: '620000', out_city_code: '08', city_id: '6227' }, { _id: '305', city_name: '庆阳市', province_id: '620000', out_city_code: '10', city_id: '6228' }, { _id: '306', city_name: '临夏回族自治州', province_id: '620000', out_city_code: '14', city_id: '6229' }, { _id: '307', city_name: '甘南藏族自治州', province_id: '620000', out_city_code: '13', city_id: '6230' }] }, { _id: '29', province_id: '630000', province_name: '青海省', province_short_name: '', spelling: '', out_pro_code: 'QH', cities: [{ _id: '308', city_name: '西宁市', province_id: '630000', out_city_code: '01', city_id: '6301' }, { _id: '309', city_name: '海东地区', province_id: '630000', out_city_code: '02', city_id: '6321' }, { _id: '310', city_name: '海北藏族自治州', province_id: '630000', out_city_code: '03', city_id: '6322' }, { _id: '311', city_name: '黄南藏族自治州', province_id: '630000', out_city_code: '09', city_id: '6323' }, { _id: '312', city_name: '海南藏族自治州', province_id: '630000', out_city_code: '04', city_id: '6325' }, { _id: '313', city_name: '果洛藏族自治州', province_id: '630000', out_city_code: '05', city_id: '6326' }, { _id: '314', city_name: '玉树藏族自治州', province_id: '630000', out_city_code: '06', city_id: '6327' }, { _id: '315', city_name: '海西蒙古族藏族自治州', province_id: '630000', out_city_code: '07', city_id: '6328' }] }, { _id: '30', province_id: '640000', province_name: '宁夏回族自治区', province_short_name: '', spelling: '', out_pro_code: 'NX', cities: [{ _id: '316', city_name: '银川市', province_id: '640000', out_city_code: '01', city_id: '6401' }, { _id: '317', city_name: '石嘴山市', province_id: '640000', out_city_code: '04', city_id: '6402' }, { _id: '318', city_name: '吴忠市', province_id: '640000', out_city_code: '06', city_id: '6403' }, { _id: '319', city_name: '固原市', province_id: '640000', out_city_code: '02', city_id: '6422' }, { _id: '320', city_name: '中卫市', province_id: '640000', out_city_code: '03', city_id: '6423' }] }, { _id: '31', province_id: '650000', province_name: '新疆维吾尔自治区', province_short_name: '', spelling: '', out_pro_code: 'XJ', cities: [{ _id: '321', city_name: '乌鲁木齐市', province_id: '650000', out_city_code: '01', city_id: '6501' }, { _id: '322', city_name: '克拉玛依市', province_id: '650000', out_city_code: '02', city_id: '6502' }, { _id: '323', city_name: '吐鲁番地区', province_id: '650000', out_city_code: '07', city_id: '6521' }, { _id: '324', city_name: '哈密地区', province_id: '650000', out_city_code: '08', city_id: '6522' }, { _id: '325', city_name: '昌吉回族自治州', province_id: '650000', out_city_code: '14', city_id: '6523' }, { _id: '326', city_name: '博尔塔拉蒙古自治州', province_id: '650000', out_city_code: '15', city_id: '6527' }, { _id: '327', city_name: '巴音郭楞蒙古自治州', province_id: '650000', out_city_code: '13', city_id: '6528' }, { _id: '328', city_name: '阿克苏地区', province_id: '650000', out_city_code: '10', city_id: '6529' }, { _id: '329', city_name: '克孜勒苏柯尔克孜自治州', province_id: '650000', out_city_code: '12', city_id: '6530' }, { _id: '330', city_name: '喀什地区', province_id: '650000', out_city_code: '11', city_id: '6531' }, { _id: '331', city_name: '和田地区', province_id: '650000', out_city_code: '09', city_id: '6532' }, { _id: '332', city_name: '伊犁哈萨克自治州', province_id: '650000', out_city_code: '16', city_id: '6540' }, { _id: '333', city_name: '塔城地区', province_id: '650000', out_city_code: '17', city_id: '6542' }, { _id: '334', city_name: '阿勒泰地区', province_id: '650000', out_city_code: '18', city_id: '6543' }] }, { _id: '32', province_id: '710000', province_name: '台湾省', province_short_name: '', spelling: '', out_pro_code: 'TW', cities: [{ _id: '442', city_name: '台湾省', province_id: '710000', out_city_code: '01', city_id: '7101' }] }, { _id: '33', province_id: '810000', province_name: '香港特别行政区', province_short_name: '', spelling: '', out_pro_code: 'XG', cities: [{ _id: '441', city_name: '香港特别行政区', province_id: '810000', out_city_code: '01', city_id: '8101' }] }, { _id: '34', province_id: '910000', province_name: '澳门特别行政区', province_short_name: '', spelling: '', out_pro_code: 'AM', cities: [{ _id: '443', city_name: '澳门特别行政区', province_id: '910000', out_city_code: '01', city_id: '9101' }] }];
      ctx.success({ data });
    } else {
      const data = await service.dictService.place();
      // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }


  // 消息类型
  async msgType() {
    const { ctx, service } = this;

    // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = [{ _id: 62, type_code: 'ALARM', type_name: '车辆提醒', create_time: 1581662130000, parent_id: 0 }, { _id: 63, type_code: 'APP_MSG', type_name: '应用消息', create_time: 1581662135000, parent_id: 0 }, { _id: 64, type_code: 'SYS_MSG', type_name: '系统消息', create_time: 1581662137000, parent_id: 0 }, { _id: 65, type_code: 'MARKETING', type_name: '服务消息', create_time: 1581662137000, parent_id: 0 }, { _id: 66, type_code: 'CMD', type_name: '命令消息', create_time: 1581662137000, parent_id: 0 }];
      ctx.success({ data });
    } else {
      const data = await service.dictService.msgType();
      // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }

  // 车系车型
  async car() {
    const { ctx, service } = this;

    // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = [{ _id: 'TEST_5W', name: 'TEST_5W', code: 'TEST_5W', children: [{ name: 'TESTL4', code: 'TESTL4' }] }, { _id: 'E111', name: 'E111', code: 'E111', children: [{ name: 'CA7306G旗舰型', code: 'ECA7306G[DBCBCDCC]' }] }, { _id: 'E-HS3', name: 'E-HS3', code: 'E-HS3', children: [{ name: 'CA7002EVA四驱豪华型南方版', code: 'CA7002EVA四驱豪华型南方版' }, { name: 'CA7001-EV', code: 'CA7001-EV' }] }, { _id: 'C229', name: 'C229', code: 'C229', children: [{ name: 'CA7205G_1', code: 'CA7205G_1' }, { name: 'EV-4WD-C229', code: 'EV-4WD-C229' }] }, { _id: 'HQE320', name: 'HQE320', code: 'HQE320', children: [{ name: 'CA7008FV[CQAA21A]', code: 'CA7008FV[CQAA21A]' }] }, { _id: 'E115', name: 'E115', code: 'E115', children: [{ name: 'CA6520H0EVXA_2', code: 'CA6520H0EVXA_2' }, { name: 'CA6520H0EVXA_1', code: 'CA6520H0EVXA_1' }] }, { _id: 'E-HS5', name: 'E-HS5', code: 'E-HS5', children: [{ name: 'CA7002-EV', code: 'CA7002-EV' }] }, { _id: 'HS7', name: 'HS7', code: 'HS7', children: [{ name: 'CA6500T旗享四驱版（六座）', code: 'CA6500T旗享四驱版（六座）' }] }];
      ctx.success({ data });
    } else {
      const data = await service.dictService.car();
      // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }


  // 远控失败类型
  async rcFailType() {
    const { ctx, service } = this;

    // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = [{ name: '远控失败' }];
      ctx.success({ data });
    } else {
      const data = await service.dictService.rcFailType();
      // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }

  // 自动化测试流程id
  async autoTest() {
    const { ctx, service } = this;

    // 调用 Service 进行业务处理
    if (ctx.isDev()) {
      const data = [{ name: 'zzzzzz111' }];
      ctx.success({ data });
    } else {
      const data = await service.dictService.autoTest();
      // 设置响应内容和响应状态码
      ctx.success({ data });
    }
  }

}

module.exports = DictController;
